///////////////////////////////////
//
//   Add-On: Baseplate Rules
//
//   ---------------------------
//
//   Author: General
//   BL ID: 4878
//
//   ---------------------------
//
//   File: server.cs
//
//   File version: 5.2
//   Last updated on: 24/05/2011
//
///////////////////////////////////



if($Server::LAN)
{
	error("ERROR: Baseplate Rules - Internet server required! Does not function on a non-internet server");
	return;
}

if(!$Pref::Server::BREnable)
{
	$Pref::Server::BREnable = 2;
	$Pref::Server::BRAppliesToAdmin = 1;
}
$BR_EnablePress = $Pref::Server::BREnable;

//Creates exception array
$BR_NumExceptions = 0;
for(%i=1;%i<getWordCount($Pref::Server::BRExceptions);%i++)
{
	if(getWord($Pref::Server::BRExceptions,%i) !$= ",")
	{
		$BR_Exception[$BR_NumExceptions] = getWord($Pref::Server::BRExceptions,%i);
		$BR_NumExceptions ++;
	}
}

package baseplateRulesServer
{
	function gameConnection::autoAdminCheck(%this)
	{
		//Sets player exception variable to 1 if on the list
		for(%i=0;%i<$BR_NumExceptions;%i++)
		{
			if(%this.BL_ID $= $BR_Exception[%i])
				%this.BRException = 1;
		}
		//Sets up client GUI
		if(%this.BL_ID == getNumKeyID())
		{
			commandToClient(%this,'BRGuiSetup',$Pref::Server::BREnable-1,$Pref::Server::BRAppliesToAdmin);
			for(%i=0;%i<$BR_NumExceptions;%i++)
				commandToClient(%this,'BRGuiSetup2',$BR_Exception[%i]);
		}
		return parent::autoAdminCheck(%this);
	}

	function serverCmdPlantBrick(%client)
	{
		parent::serverCmdPlantBrick(%client);
		if($Pref::Server::BREnable == 2)
		{
			if(%client.bl_id == getNumKeyID())
				return;
			if($Pref::Server::BRAppliesToAdmin == 1 && %client.isSuperAdmin)
				return;
			if($Pref::Server::BRAppliesToAdmin == 2 && %client.isAdmin)
				return;
			if(%client.BRException)
				return;
			%plantedBrick = %client.brickGroup.getObject(%client.brickGroup.getCount() - 1);
			if(%plantedBrick.getDistanceFromGround() == 0 && %plantedBrick.getDatablock().category !$= "Baseplates")
			{
				%plantedBrick.delete();
				commandToClient(%client,'MessageBoxOK',"Invalid Brick","You must start with a Baseplate.<bitmap:base/client/ui/brickIcons/16x16 Base>");
			}
		}
	}

	function serverCmdBRenable($BR_Client)
	{
		if($BR_Client.BL_ID == getNumKeyID())
		{
			cancel($BR_EnableSchedule);
			if($BR_EnablePress == 1)
				$BR_EnablePress = 2;
			else
				$BR_EnablePress = 1;
			if($Pref::Server::BREnable == 2)
			{
				//Scheduled to avoid spamming
				$BR_EnableSchedule = schedule(1000,0,eval,"if($Pref::Server::BREnable != $BR_EnablePress) { messageAll('MsgAdminForce',\"\c3Baseplate Rules\c0 disabled.\"); $BR_EnablePress = 1; $Pref::Server::BREnable = 1; commandToClient($BR_Client,'BRenable',$Pref::Server::BREnable - 1); }");
			}
			if($Pref::Server::BREnable == 1)
			{
				$BR_EnableSchedule = schedule(1000,0,eval,"if($Pref::Server::BREnable != $BR_EnablePress) { messageAll('MsgAdminForce',\"\c3Baseplate Rules\c0 enabled.\"); $BR_EnablePress = 2; $Pref::Server::BREnable = 2; commandToClient($BR_Client,'BRenable',$Pref::Server::BREnable - 1); }");
			}
		}
	}

	function serverCmdBRsetAdmin(%client,%val,%gui)
	{
		if(%client.BL_ID == getNumKeyID())
		{
			if($Pref::Server::BREnable == 1)
			{
				if(!%gui)
					messageClient(%client,'',"\c3Baseplate Rules \c0are disabled, you must enable them before changing any preferences.");
				commandToClient(%client,'BRsetAdmin',$Pref::Server::BRAppliesToAdmin);
				return;
			}
			//Error if value is incorrect
			if(%val < 0 || %val > 2 || %val $= "")
			{
				messageClient(%client,'',"Value incorrect, type \c3/BRsetAdmin value \c0into the chat replacing \c3value \c0with one of the numbers below:");
				messageClient(%client,'',"\c30 \c0= \c3Super (Admins)");
				messageClient(%client,'',"\c31 \c0= \c3Admins");
				messageClient(%client,'',"\c32 \c0= \c3No Admin");
				return;
			}
			commandToClient(%client,'BRsetAdmin',%val);
			if(%val == 0)
			{
				$Pref::Server::BRAppliesToAdmin = 0;
				if(!%gui)
					messageClient(%client,'',"Rule applies to \c3Super (Admins)");
			}
			if(%val == 1)
			{
				$Pref::Server::BRAppliesToAdmin = 1;
				if(!%gui)
					messageClient(%client,'',"Rule applies to \c3Admins");
			}
			if(%val == 2)
			{
				$Pref::Server::BRAppliesToAdmin = 2;
				if(!%gui)
					messageClient(%client,'',"Rule applies to \c3No Admin");
			}
		}
	}

	function serverCmdBRexceptionRemove(%client,%ID,%gui)
	{
		if(%client.BL_ID == getNumKeyID())
		{
			if($Pref::Server::BREnable == 1)
			{
				messageClient(%client,'',"\c3Baseplate Rules \c0are disabled, you must enable them before changing any preferences.");
				return;
			}
			//Checks the string for errors
			%error = BRinsertError(%client,%ID,%gui,1);
			if(%error $= "ERROR")
				return;
			//Removes ID from list
			for(%i=0;%i<$BR_NumExceptions;%i++)
			{
				if(%ID == $BR_Exception[%i])
				{
					if(!%gui)
						messageClient(%client,'',"ID has been removed from the exception list.");
					for(%j=%i;%j<$BR_NumExceptions;%j++)
					{
						$BR_Exception[%j] = $BR_Exception[%j+1];
					}
					$BR_NumExceptions --;
					%found = 1;
				}
			}
			//Error if ID not found on the list
			if(!%found)
			{
				if(!%gui)
					messageClient(%client,'',"Unable to find ID on the exception list.");
				return;
			}
			//Finds player with the same ID as removed from the list and sets their exception variable to 0
			for(%i=0;%i<clientGroup.getCount();%i++)
			{
				if(clientGroup.getObject(%i).BL_ID $= %ID)
					clientGroup.getObject(%i).BRException = 0;
			}
			commandToClient(%client,'BRexceptionRemove',%ID);
			BRexceptionEvaluate();
		}
	}

	function serverCmdBRexceptionAdd(%client,%ID,%gui)
	{
		if(%client.BL_ID == getNumKeyID())
		{
			if($Pref::Server::BREnable == 1)
			{
				messageClient(%client,'',"\c3Baseplate Rules \c0are disabled, you must enable them before changing any preferences.");
				return;
			}
			//Checks the string for errors
			%error = BRinsertError(%client,%ID,%gui);
			if(%error $= "ERROR")
				return;
			//Error if ID is already on the list
			for(%i=0;%i<$BR_NumExceptions+1;%i++)
			{
				if($BR_Exception[%i] $= %ID)
				{
					if(!%gui)
						messageClient(%client,'',"ID is already on the list.");
					commandToClient(%client,'BRexceptionError');
					return;
				}
			}
			//Finds player with the same ID as added to the list and sets their exception variable to 1
			for(%i=0;%i<clientGroup.getCount();%i++)
			{
				if(clientGroup.getObject(%i).BL_ID $= %ID)
					clientGroup.getObject(%i).BRException = 1;
			}
			//Adds ID to exception array
			$BR_Exception[$BR_NumExceptions] = %ID;
			$BR_NumExceptions ++;
			commandToClient(%client,'BRexceptionAdd',%ID);
			BRexceptionEvaluate();
			if(!%gui)
				messageClient(%client,'',"ID has been added to the exception list.");
		}
	}
	
	function serverCmdBRstate(%client)
	{
		if(%client.BL_ID == getNumKeyID())
		{
			//Prepares variables
			if($Pref::Server::BREnable == 2)
				%enabled = "Yes";
			else
				%enabled = "No";
			if($Pref::Server::BRAppliesToAdmin == 0)
				%admin = "Super (Admins)";
			if($Pref::Server::BRAppliesToAdmin == 1)
				%admin = "Admins";
			if($Pref::Server::BRAppliesToAdmin == 2)
				%admin = "No Admin";
			if($BR_NumExceptions == 0)
				%exceptions = "None";
			//Messages the variables
			messageClient(%client,'',"---\c3Baseplate Rules - State\c0------------");
			messageClient(%client,'',"Enabled: \c3" @ %enabled);
			messageClient(%client,'',"Applies to: \c3" @ %admin);
			messageClient(%client,'',"Exceptions: \c3" @ %exceptions);
			for(%i=0;%i<$BR_NumExceptions;%i++)
			{
				messageClient(%client,'',"\c3" @ $BR_Exception[%i]);
			}
			messageClient(%client,'',"--------------------------------------------");
		}
	}
	
	function serverCmdBRcommandHelp(%client)
	{
		if(%client.BL_ID == getNumKeyID())
		{
			messageClient(%client,'',"---\c3Baseplate Rules - Command Help\c0------------");
			messageClient(%client,'',"\c3/BR \c0- Opens the mod's preference manager. This command only works if you have this mod on the copy of Blockland you are using.");
			messageClient(%client,'',"\c3/BRstate \c0- Displays the current state of the mod.");
			messageClient(%client,''," ");
			messageClient(%client,'',"\c3/BRenable \c0- Toggles the mod on/off.");
			messageClient(%client,'',"\c3/BRsetAdmin value \c0- Assigns the rule to a specified admin group. Replace \c3value \c0with:");
			messageClient(%client,'',"     \c30 \c0for \c3Super (Admins)");
			messageClient(%client,'',"     \c31 \c0for \c3Admins");
			messageClient(%client,'',"     \c32 \c0for \c3No Admin");
			messageClient(%client,'',"\c3/BRexceptionAdd ID \c0- Adds a specified ID to the rule exception list.");
			messageClient(%client,'',"\c3/BRexceptionRemove ID \c0- Removes a specified ID from the rule exception list.");
			messageClient(%client,'',"-----------------------------------------------------------");
		}
	}		

	function serverCmdBR(%client)
	{
		if(%client.bl_id == getNumKeyID())
			commandToClient(%client,'BRopenGui');
	}

	//Creates the preference string
	function BRexceptionEvaluate()
	{
		$Pref::Server::BRExceptions = "";
		for(%i=0;%i<$BR_NumExceptions;%i++)
		{
			$Pref::Server::BRExceptions = $Pref::Server::BRExceptions @ " " @ $BR_Exception[%i] @ " ,";
		}
		if($Pref::Server::BRExceptions $= "")
			$Pref::Server::BRExceptions = " ";
	}

	//Checks for exception adding/removing string errors
	function BRinsertError(%client,%ID,%gui,%ir)
	{
		%length = strLen(%ID);
		//Error if string equals to nothing
		if(%ID $= "")
		{
			if(!%gui)
				messageClient(%client,'',"You must insert something!");
			if(!%ir)
				commandToClient(%client,'BRexceptionError');
			%ID = "ERROR";
			return %ID;
		}
		//Error if string contains a 0 at its beginning (impossible ID)
		if(getSubStr(%ID, 0, 1) $= "0" && %length > 1)
		{
			if(!%gui)
				messageClient(%client,'',"Your ID cannot start with a 0.");
			commandToClient(%client,'BRexceptionError');
			%ID = "ERROR";
			return %ID;
		}
		//Error if string contains any character other than numbers
		for(%i=0;%i<10;%i++)
		{
			if(%i==0)
				%r0 = strReplace(%ID,0,"");
			else
				%r[%i] = strReplace(%r[%i-1],%i,"");
		}
		if(%r9 !$= "")
		{
			if(!%gui)
				messageClient(%client,'',"Your ID can only contain numbers.");
			commandToClient(%client,'BRexceptionError');
			%ID = "ERROR";
			return %ID;
		}
		return %ID;
	}
};
if(isPackage(baseplateRulesServer))
	deactivatePackage(baseplateRulesServer);
activatePackage("baseplateRulesServer");

// Line 349 :3